//SQ7515_DIV()
//*************************************************************************************
// 	: main.c
// 汾		: V1.1 2022/06/08
// 		: 
// ˵	: ֱ°1~3ִMAC_DIVMACA/MACB=MACC
//
//			  °1: ()a = 0x44B17E22, ()b = 0x00000045, :()c=0x00FEDCBA, ȷ LED1
//      	  °2: ()a = 0x00001234, ()b = 0x00005678, :()c=0x00000000, ȷ LED2
//      	  °3: ()a = 0xFEDCBA98, ()b = 0x01234567, :()c=0x000000E0, ȷ LED3
//            * ſLED𣬵ȴʹһ
//
// ע		: [] 1  BTN1_in(P3.0)
//						 2  BTN2_in(P3.1)
//						 3  BTN3_in(P3.2)
//			   [LED] LED 1  (P2.0)
//			   [LED] LED 2  (P3.7)
//			   [LED] LED 3  (P3.6)
//**************************************************************************************

#ifndef	IO_MEM
#define	IO_MEM
#endif
#include "main.h"

/* ----------------------  -------------------------- */


/* -----------------------  --------------------------- */
void main(){
    unsigned long a;
    unsigned long b;
    unsigned long c; 
    unsigned char temp;
/* -------------  ----------------------- */
    P0PU = 0xFF;
    P1PU = 0xFF;
    P2PU = 0xFF;
    P3PU = 0xFF;
    P4PU = 0xFF;
    P5PU = 0xFF;
    
/* ---------------------- ϵͳʼ ------------------------ */
    PLLCR0_PLLEN  = 1;                  //  PLL
    while(Is_PLL_Busy());               // ȴ PLL     
    CLKCR0_SCKPSC = 1;                  // ϵͳƵʳ2   (48M/2=24MHz)
    CLKCR0_SCKSRC = 1;                  // ʱԴлPLL
    while(Is_SysClk_Busy());            // ȴ ϵͳʱ 
/* ---------------------- ܽųʼ ------------------------ */
    P2OE_P0 = 1;                        // 趨P2.0 ܽΪ
    P2PU_P0 = 0;                        // 趨P2.0 .

    P3OE_P7 = 1;                        // 趨P3.7 ܽΪ
    P3PU_P7 = 0;                        // 趨P3.7 .

    P3OE_P6 = 1;                        // 趨P3.6 ܽΪ
    P3PU_P6 = 0;                        // 趨P3.6 .

    LED1_out = 1;                       // ʼ趨LED1Ϊ״̬
    LED2_out = 1;                       // ʼ趨LED2Ϊ״̬
    LED3_out = 1;                       // ʼ趨LED3Ϊ״̬

/* ---------------------- DIV ʼ ------------------------ */		                                    
    DIV_Init();                         	  // DIVʼ
    //--------------------------------------------------------------------
    while(1){
        if((P3DI & 0x07) != 0x07){
            if(BTN1_in == 0){                   // °1  BTN1_in(P3.0)

                a = 0x44B17E22;                 // 
                b = 0x00000045;                 // 
                c = 1;

                *(unsigned long*)&MACC0 = c;    // CMACC0 	
                *(unsigned long*)&MACA0 = a;    // AMACA0 
                *(unsigned long*)&MACB0 = b;    // BMACB0 

                MACCR0_MODE = MAC_Mode_DIV;     // ģʽѡ (MACDIV) 0x08		
		
                MACCR1_START = 1;               // ʼ(DIV)
                while(MACCR1_START);            // DIV

                c = *(unsigned long*)&MACC0;    // ֮Żc [MACC0]
                a = *(unsigned long*)&MACA0;    // ֮Ża [MACA0]

                if(Is_MACCR1_Div_Error()){      // 
                    MACCR1_DIVERR = 1;    	    // e`
                    __ASM("NOP");				// ָ
                }

                if((c != 0x00FEDCBA) || (a != 0x00000000)){     // ȷֵDIV
                    __ASM("NOP");               // ָ
                }
                else{                           // DIVȷLED1
                    LED1_out = 0;
                }

            }
            //------------------------------------------------------------------------
            else if(BTN2_in == 0){              // °2  BTN2_in(P3.1)

                a = 0x00001234;  //
                b = 0x00005678;  //
                c = 0;
                *(unsigned long*)&MACC0 = c;    // CMACC 
                *(unsigned long*)&MACA0 = a;    // AMACA 
                *(unsigned long*)&MACB0 = b;    // BMACB 

                MACCR0_MODE = MAC_Mode_DIV;     // ģʽѡ (MACDIV) 0x08		

                MACCR1_START = 1;               // ʼ(DIV)
                while(MACCR1_START);            // DIV

                c = *(unsigned long*)&MACC0;    // ֮Żc [MACC0]
                a = *(unsigned long*)&MACA0;    // ֮Ża [MACA0]

                if(Is_MACCR1_Div_Error()){      // 
                    MACCR1_DIVERR = 1;    	    // e`
                    __ASM("NOP");               // ָ
                }

                if((c != 0x00000000) || (a != 0x00001234)){     // ȷֵDIV           
                    __ASM("NOP");               // ָ
                }
                else{                           // DIVȷLED2
                    LED2_out = 0;
                }
	
            }
            //------------------------------------------------------------------------
            else if(BTN3_in == 0){              // °3  BTN3_in(P3.2)

                a = 0xFEDCBA98;  //
                b = 0x01234567;  //
                c = 0;

                *(unsigned long*)&MACC0 = c;    // CMACC 
                *(unsigned long*)&MACA0 = a;    // AMACA 
                *(unsigned long*)&MACB0 = b;    // BMACB 

                MACCR0_MODE = MAC_Mode_DIV;     // ģʽѡ (MACDIV) 0x08		

                MACCR1_START = 1;               // ʼ(DIV)
                while(MACCR1_START);            // DIV

                c = *(unsigned long*)&MACC0;    // ֮Żc [MACC0]
                a = *(unsigned long*)&MACA0;    // ֮Ża [MACA0]

                if(Is_MACCR1_Div_Error()){      // 
                    MACCR1_DIVERR = 1;    	    // e`
                    __ASM("NOP");               // ָ
                }

                if((c != 0x000000E0) || (a != 0x00000078)){     // ȷֵDIVYe`
                    __ASM("NOP");               // ָ
                }
                else{                           // DIVY_,LED3
                    LED3_out = 0;
                }
            }
            //------------------------------------------------------------------------
            while((P3DI & 0x07) != 0x07);       // ȴͷ    

            LED1_out = 1;                       // ʹLED1~3
            LED2_out = 1;
            LED3_out = 1; 			
        }
    }
}


/* ---------------------- жϷ ------------------------ */
void __interrupt OnlyReti(void){
    __asm("NOP");                       // ָ
}

void __interrupt_n OnlyRetn(void){
    __asm("NOP");                       // ָ
}

void __interrupt_n IntWDT(void){
    __asm("NOP");                       // ָ
}

void __interrupt_n IntSWI(void){        // SWIλжϷ
    PRSTR7 = 0x5a;
    PRSTR7 = 0xa5;
    PRSTR7 = 0xc3;
    PRSTR7 = 0x3c;	
}
/* -------------------  жϷ ---------------------- */

/* -------------------- SQ7515ж ------------------ */
#pragma section const INT_VECTOR1 0xff40
void * const IntTbl1[] = {											
	OnlyReti,				/* 0xff40 : Reserved		*/									
	OnlyReti,				/* 0xff42 : Reserved		*/									
	OnlyReti,				/* 0xff44 : Reserved		*/									
	OnlyReti,				/* 0xff46 : Reserved		*/								
	OnlyReti,				/* 0xff48 : Reserved		*/									
	OnlyReti,				/* 0xff4a : Reserved		*/									
	OnlyReti,				/* 0xff4c : Reserved		*/									
	OnlyReti,				/* 0xff4e : Reserved		*/									
	OnlyReti,				/* 0xff50 : Reserved		*/									
	OnlyReti,				/* 0xff52 : Reserved		*/									
	OnlyReti,				/* 0xff54 : Reserved		*/									
	OnlyReti,				/* 0xff56 : Reserved		*/									
	OnlyReti,				/* 0xff58 : IntTCA7			*/	//жԴ:TCA7 16λʱ								
	OnlyReti,				/* 0xff5a : IntTCA6			*/	//жԴ:TCA6 16λʱ							
	OnlyReti,				/* 0xff5c : Reserved		*/									
	OnlyReti,				/* 0xff5e : Reserved		*/									
	OnlyReti,				/* 0xff60 : Reserved		*/									
	OnlyReti,				/* 0xff62 : Reserved		*/									
	OnlyReti,				/* 0xff64 : Reserved		*/									
	OnlyReti,				/* 0xff66 : Reserved		*/									
	OnlyReti,				/* 0xff68 : Reserved		*/									
	OnlyReti,				/* 0xff6a : Reserved		*/									
	OnlyReti,				/* 0xff6c : IntTX2			*/	//жԴ:UART2 TX2								
	OnlyReti,				/* 0xff6e : IntRX2			*/	//жԴ:UART2 RX2							
	OnlyReti,				/* 0xff70 : Reserved		*/									
	OnlyReti,				/* 0xff72 : Reserved		*/									
	OnlyReti,				/* 0xff74 : Reserved		*/									
	OnlyReti,				/* 0xff76 : IntTCA5			*/	//жԴ:TCA5 16λʱ								
	OnlyReti,				/* 0xff78 : IntTCA4			*/	//жԴ:TCA4 16λʱ								
	OnlyReti,				/* 0xff7a : Reserved		*/									
	OnlyReti,				/* 0xff7c : Reserved		*/									
	OnlyReti,				/* 0xff7e : Reserved		*/									
	OnlyReti,				/* 0xff80 : Reserved		*/									
	OnlyReti,		    	/* 0xff82 : Reserved		*/									
	OnlyReti,	    		/* 0xff84 : Reserved		*/									
	OnlyReti,				/* 0xff86 : Reserved		*/									
	OnlyReti,				/* 0xff88 : Reserved		*/									
	OnlyReti,				/* 0xff8a : Reserved		*/									
	OnlyReti,				/* 0xff8c : IntSIO1			*/	//жԴ:SIO 1								
	OnlyReti,				/* 0xff8e : IntI2C1			*/	//жԴ:I2C 1						
	OnlyReti,				/* 0xff90 : IntTX1			*/	//жԴ:UART1 TX1							
	OnlyReti,				/* 0xff92 : IntRX1			*/	//жԴ:UART1 RX1								
	OnlyReti,				/* 0xff94 : Reserved		*/									
	OnlyReti,				/* 0xff96 : Reserved		*/									
	OnlyReti,				/* 0xff98 : Reserved		*/									
	OnlyReti,				/* 0xff9a : IntTCA3			*/	//жԴ:TCA3 16λʱ							
	OnlyReti,				/* 0xff9c : IntTCA2			*/	//жԴ:TCA2 16λʱ								
	OnlyReti,				/* 0xff9e : Reserved		*/									
	OnlyReti,				/* 0xffa0 : IntMAC			*/	//жԴ:˷								
	OnlyReti,				/* 0xffa2 : IntEINT7		*/	//ⲿж7								
	OnlyReti,				/* 0xffa4 : IntEINT6		*/	//ⲿж6								
	OnlyReti,				/* 0xffa6 : IntEINT5		*/	//ⲿж5								
	OnlyReti,				/* 0xffa8 : IntEINT4		*/	//ⲿж4								
	OnlyReti,				/* 0xffaa : Reserved		*/									
	OnlyReti,				/* 0xffac : Reserved		*/									
	OnlyReti,				/* 0xffae : Reserved		*/							
	OnlyReti,				/* 0xffb0 : IntDIC			*/	//жԴ:DIC								
	OnlyReti,				/* 0xffb2 : Reserved		*/							
	OnlyReti,				/* 0xffb4 : Reserved		*/									
	OnlyReti,				/* 0xffb6 : Reserved		*/									
	OnlyReti,				/* 0xffb8 : Reserved		*/									
	OnlyReti,				/* 0xffba : Reserved		*/									
	OnlyReti,				/* 0xffbc : Reserved		*/									
	OnlyReti,				/* 0xffbe : Reserved		*/									
	OnlyReti,				/* 0xffc0 : Reserved		*/									
	OnlyReti,				/* 0xffc2 : Reserved		*/									
	OnlyReti,				/* 0xffc4 : IntFMC			*/	//жԴ:Flash								
	OnlyReti,				/* 0xffc6 : Reserved		*/					
	OnlyReti,				/* 0xffc8 : Reserved		*/									
	OnlyReti,				/* 0xffca : Reserved		*/									
	OnlyReti,				/* 0xffcc : Reserved		*/									
	OnlyReti,               /* 0xffce : IntADC			*/	//жԴ:ADC								
	OnlyReti,				/* 0xffd0 : IntEINT3		*/	//ⲿж3								
	OnlyReti,				/* 0xffd2 : IntEINT2		*/	//ⲿж2								
	OnlyReti,				/* 0xffd4 : IntEINT1		*/	//ⲿж1								
	OnlyReti,				/* 0xffd6 : IntEX0			*/	//ⲿж0								
	OnlyReti,				/* 0xffd8 : IntSIO0			*/	//жԴ:SIO 0								
	OnlyReti,				/* 0xffda : IntI2C0			*/	//жԴ:I2C 0								
	OnlyReti,				/* 0xffdc : IntTX0			*/	//жԴ:UART0 TX0								
	OnlyReti,				/* 0xffde : IntRX0			*/	//жԴ:UART0 RX0								
	OnlyReti,				/* 0xffe0 : Reserved		*/									
	OnlyReti,				/* 0xffe2 : Reserved		*/									
	OnlyReti,				/* 0xffe4 : Reserved		*/									
	OnlyReti,				/* 0xffe6 : IntTCA1			*/	//жԴ:TCA1 16λʱ								
	OnlyReti,				/* 0xffe8 : IntTCA0			*/	//жԴ:TCA0 16λʱ								
	OnlyReti,				/* 0xffea : Reserved		*/									
	OnlyReti,				/* 0xffec : Reserved		*/									
	OnlyReti,			    /* 0xffee : IntRTC			*/	//жԴ:ʵʱʱRTCʱ								
	OnlyReti,				/* 0xfff0 : IntTBT			*/  //жԴ:ʱTBTʱ				
	OnlyReti,				/* 0xfff2 : Reserved		*/									
	OnlyReti,				/* 0xfff4 : IntCFD			*/	//жԴ:ʱʧЧ								
	OnlyReti,				/* 0xfff6 : IntLVD			*/	//жԴ:͵ѹLVD							
	IntWDT,					/* 0xfff8 : IntWDT			*/	//non-maskable жԴ:Źʱ		
	(void *)0xffff,			/* 0xfffa : Reserved		*/									
	IntSWI,					/* 0xfffc : IntSWI/INTUNDEF */	//non-maskable		
	STARTUP					/* 0xfffe : RESET			*/	//non-maskable			
};
#pragma section const
/* -------------------  SQ7515ж ---------------------- */

