//*************************************************************************************
// 	: SQ7515_FMC.c
// 汾		: V1.0
// 		: FMC ʹú
// ע		: FMC غ㼯ڱӳ
//**************************************************************************************
#include "main.h"


//*********************************************************************
// 	: FMC_Init()
// 	: Flash ʱӷƵ(FCKDIV)
// ע		: 
//            sysclk : System clock frequency in MHz        
//*********************************************************************
void FMC_Init(unsigned char sysclk)
{
	FCKDIV = sysclk - 1;
}

//*********************************************************************
// 	: FMC_PageErase()
// 	: Flash ҳ
// شֵ   : 0: ɹ  
//            1: ʧ 
// ע		: 
//*********************************************************************
unsigned char FMC_PageErase(unsigned int address)
{
    unsigned char status,tmp8;
	unsigned int  iAddr,startAddr,endAddr;
	
	FADDR0 = (unsigned char)address & 0x00FF;        	// 趨λַĴ
	FADDR1 = (unsigned char)(address >> 8) & 0x00FF;
	
	FCR0_FCMD = 0x02;                                	// ҳ
	
	do{	                                             	// ȴFLASH퓲
	    status = FCR1;
        status &= 0x80; 		  
	}while(status);

	startAddr 	= address & 0xfe00;
	endAddr		= address | 0x01ff;	
	for(iAddr=startAddr;iAddr <=endAddr ;iAddr++){
		FMC_ReadByte(iAddr,&tmp8);	
		if( tmp8!= 0xff){
			return 1;									// ʧ
		}
	}
	
	return 0;
}

//*********************************************************************
// 	: FMC_WriteByte()
// 	: ָλַдһByte
// شֵ    : 0:дɹ  
//             1:дʧ<дԤֵͬ>  
// ע		: 
//*********************************************************************
unsigned char FMC_WriteByte(unsigned int address, unsigned char data)
{
	unsigned char status,tmp8;

	FMC_ReadByte(address,&tmp8);	
	if( tmp8 != 0xff)
		return 2;									   	// дǰΪ(0xff)
	
	FCR0_DATASZ0 = 0x00;    						   	// 趨FALSHݳΪBYTE
		
	FDATA0 = data;                                     	// дݼĴ 
	
	FADDR0 = (unsigned char)address & 0x00FF;         // OλַĴ
	FADDR1 = (unsigned char)(address >> 8) & 0x00FF;
	 
	FCR0_FCMD = 0x01;                                  	//  
	
	do{                                                 // ȴFLASHд빤
	    status = FCR1;
        status &= 0x80; 		  
	}while(status);
	
	FMC_ReadByte(address,&tmp8);	
	if( tmp8 != data)
		return 1;										// дʧ
	
	
	return 0;											// дɹ
	
}


//*********************************************************************
// 	: FMC_ReadByte()
// 	: ָλַһByte
// ע		: 
//*********************************************************************
void FMC_ReadByte(unsigned int address, unsigned char* data)
{
	FADDR0 = (unsigned char)address & 0x00FF;         // 趨λַĴ
	FADDR1 = (unsigned char)(address >> 8) & 0x00FF;
   
    FCR0_FCMD = 0x00;                                   // ݶȡ        
	*data = FDATA0;                                     // ݼĴ

}


//*********************************************************************
// 	: FMC_IntEnable()
// 	: FMCж
// ע		: 
//*********************************************************************
void FMC_IntEnable(){
	__ASM("DI");						// ֹпж
	IER_FMC = 1;                   		// FMCж
	__ASM("EI");						// пж
}


//*********************************************************************
// 	: __interrupt IntFMC()
// 	: FMC жӳ
// ע		:
//*********************************************************************
void __interrupt IntFMC(void)
{
	__asm("NOP");						// ָ

}



