//*************************************************************************************
// 	: SQ7515_SecureUnit_I2C_HAL.c
// 汾		: V1.0
// 		: SecureUnit  i2c Ӳ㺯
// ע		:
// ʷ     :
//**************************************************************************************
/* ---------------------- ͷļ ------------------------------ */
#include "main.h"

/* ---------------------- ṹ ------------------------------ */

/* ----------------------  ------------------------------------ */

/* ---------------------- ȫ ---------------------------- */

/* ---------------------- ر ---------------------------- */

/* ---------------------- غԭ ------------------------ */

/* ---------------------- ʽa ---------------------------------- */

//*********************************************************************
// 	: I2C_Data_Transmit()
// 	: ͨ I2C  SecureUnit дֽ
//      : wBuffer - ָҪдݻָ
//            Length  - Ҫдֽڳ
// شֵ   : I2C HAL result
// ע		: 
//*********************************************************************
I2C_HAL_Ret I2C_Data_Transmit(uint8_t* Wbuffer, uint8_t Length)
{
    I2C_MasterPacket i2c_master;

    i2c_master.adr = SLAVE_ADDR;
    i2c_master.len = Length;
	i2c_master.pBuf = Wbuffer; 
	
    if(I2C_Master_Write(I2C_CHANNEL,&i2c_master)==0){
        return I2C_HAL_RET_NACK;
    }

	return I2C_HAL_RET_OK;		
	
}


//*********************************************************************
// 	: I2C_Data_Receive()
// 	: ͨ I2C  SecureUnit ֽ
//      : Rbuffer - ջָ
// شֵ   : I2C HAL result
// ע		: 
//*********************************************************************
I2C_HAL_Ret I2C_Data_Receive(uint8_t* Rbuffer)
{    
    I2C_MasterPacket i2c_master;
    unsigned char rdsr[4]={0x04,0xF0,0x3E,0xD4}; 

    i2c_master.adr = SLAVE_ADDR;
    i2c_master.len = 4;
	i2c_master.pBuf = rdsr; 

    if(I2C_Master_Write(I2C_CHANNEL,&i2c_master)==0){
        return I2C_HAL_RET_NACK;
    }

    i2c_master.adr = SLAVE_ADDR;
 	i2c_master.pBuf = Rbuffer; 
	
    if(I2C_Master_Read(I2C_CHANNEL,&i2c_master)==0){
		return I2C_HAL_RET_NACK;
    }

	return I2C_HAL_RET_OK;

}

/* ------------------- ļβ  ---------------------- */
