//*************************************************************************************
// 	: SQ7515_SecureUnit_I2C.c
// 汾		: V1.0
// 		: SecureUnit  i2c 
// ע		:
// ʷ     :
//**************************************************************************************
/* ---------------------- ͷļ ------------------------------ */
#include "main.h"

/* ---------------------- ṹ ------------------------------ */

/* ----------------------  ------------------------------------ */

/* ---------------------- ȫ ---------------------------- */

/* ---------------------- ر ---------------------------- */

/* ---------------------- غԭ ------------------------ */


/* ---------------------- ʽa ---------------------------------- */

//*********************************************************************
// 	: I2C0_Init()
// 	: I2C0ʼ
//      : 
// شֵ   : 
// ע		: I2C0 ùܽšģʽ
//			  *趨I2C0ΪSlave mode , Slave address = 0x68 
//*********************************************************************
void I2C0_Init(){

	
//====== I2C0ܽųʼ ======
	//--SDA0 (P0.5) ; SCL0 (P0.6)------- [ѡܽ]
	P0FC1_P5 = 1;                       // P0.5趨ΪSDA0
	P0FC2_P5 = 0;
	P0FC1_P6 = 1;                       // P0.6趨ΪSCL0
	P0FC2_P6 = 0;
	FSELR0 |= 0x30;						// 趨ѡĴ0
	PCSELR1_I2C0 = 0x00;				// 趨ΧͨѡĴ

/*	
	//--SDA0 (P0.4) ; SCL0 (P0.5)-------
	P0FC1_P4 = 1;                       // P0.4趨ΪSDA0
	P0FC2_P4 = 0;
	P0FC1_P5 = 1;                       // P0.5趨ΪSCL0
	P0FC2_P5 = 0;
	FSELR0 |= 0x40;						// 趨ѡĴ0
	PCSELR1_I2C0 = 0x01;				// 趨ΧͨѡĴ
*/	


/*
	//--SDA0 (P2.5) ; SCL0 (P2.4)-------
	P2FC1_P5 = 1;                       // P2.5趨ΪSDA0
	P2FC2_P5 = 0;
	P2FC1_P4 = 1;                       // P2.4趨ΪSCL0
	P2FC2_P4 = 0;
	FSELR2 |= 0x30;						// 趨ѡĴ2
	PCSELR1_I2C0 = 0x02;				// 趨ΧͨѡĴ
*/	

	
/*	
	//--SDA0 (P3.2) ; SCL0 (P3.3)-------
	P3FC1_P2 = 1;                       // P3.2趨ΪSDA0
	P3FC2_P2 = 0;
	P3FC1_P3 = 1;                       // P3.3趨ΪSCL0
	P3FC2_P3 = 0;
	FSELR3 |= 0x00;						// 趨ѡĴ3
	PCSELR1_I2C0 = 0x03;				// 趨ΧͨѡĴ
*/


//====== I2C0 ======
	PCKEN2_I2C0 = 1;                    // I2C0
	SBI0CR1_SCK = SCK_HI_135_LO_138;    // ģʽƵʿ ; ģʽƵʽλ(SCL pin)ʱ ֮趨
	
	SBI0CR1_ACK = 1;                    // Ӧģʽ(ACK enable)
	SBI0CR1_BC = 0x00;                  // (λ)9bit = 8bit + 1bit(ACK)


	
//--- [I2C0ΪSlave] ---				*I2C0ΪSlave
	//------------bit7 | bit6 | bit5 | bit4  |  bit3  | bit2 | bit1~bit0 ----
	//--- SBI0CR2 <MST>, <TRX>, <BB>, <PIN> and <SBIM>  <NA>   <SWRST>   ----
	//--- <MST>   1 : Master
	//            0 : Slave
	//--- <TRX>   1 :    ; 0: 
	//--- <BB>    1 : ʼ
	//            0 : ֹͣ
	//--- <PIN>	  1 : ȡжϷ
	//
	//--- <SBIM>  1 : Serial bus interface mode(ģʽ) / 0:Port mode
	//--- <SWRST> ÿʼλ  
	//------------------------------------------------------------------------
	

	//---I2C0ΪSlave趨Slaveַ
	I2C0AR = SLAVE_ADDR << 1;			// ôģʽַ(Slaveַ)SA[7:1]
	
	//---ΪSlave mode趨 SBICR2<PIN> , <SBIM>
	SBI0CR2 = 0x18;						// Slave mode 0001 1000
	

	
	
}


//*********************************************************************
// 	: I2C0_IntEnable()
// 	: I2C0ж
//      : 
// شֵ   : 
// ע		: ִкῪж(IMF)**
//*********************************************************************
void I2C0_IntEnable(void)
{
	__ASM("DI");						// ֹпж
	IFR_I2C0 = 0;                       // ж
	IER_I2C0 = 1;	                    // I2C0ж(Enable) 
	__ASM("EI");						// пж
}


//*********************************************************************
// 	: I2C0_IntDisable() 
// 	: ֹI2C0ж
//      : 
// شֵ   : 
// ע		: ִкῪж(IMF)**
//*********************************************************************
void I2C0_IntDisable(void)
{
	__ASM("DI");						// ֹпж
	IFR_I2C0 = 0;                       // ж
	IER_I2C0 = 0;	                    // I2C0жϽֹ 
	__ASM("EI");						// пж
}



//*********************************************************************
// 	: I2C1_Init()
// 	: I2C1ʼ
//      : 
// شֵ   : 
// ע		: I2C1 ùܽšģʽ
//			  *趨I2C1ΪMaster mode
//*********************************************************************
void I2C1_Init(){
	
	
//====== I2C1ܽųʼ ======

/*
	//--SDA1 (P0.0) ; SCL1 (P0.2)-------
	P0FC1_P0 = 1;                       // P0.0趨ΪSDA1
	P0FC2_P0 = 0;
	P0FC1_P2 = 1;                       // P0.2趨ΪSCL1
	P0FC2_P2 = 0;
	FSELR0 |= 0x03;						// 趨ѡĴ0
	PCSELR1_I2C1 = 0x00;				// 趨ΧͨѡĴ
*/

	//--SDA1 (P2.1) ; SCL1 (P2.2)-------
	P2FC1_P1 = 1;                       // P2.1趨ΪSDA1
	P2FC2_P1 = 0;
	P2FC1_P2 = 1;                       // P2.2趨ΪSCL1
	P2FC2_P2 = 0;
	FSELR2 |= 0x00;						// 趨ѡĴ2
	PCSELR1_I2C1 = 0x01;				// 趨ΧͨѡĴ


/*

	//--SDA1 (P4.6) ; SCL1 (P4.7)-------  [ѡܽ]
	P4FC1_P6 = 1;                       // P4.6趨ΪSDA1
	P4FC2_P6 = 0;
	P4FC1_P7 = 1;                       // P4.7趨ΪSCL1
	P4FC2_P7 = 0;
	FSELR4 |= 0x30;						// 趨ѡĴ4
	PCSELR1_I2C1 = 0x02;				// 趨ΧͨѡĴ
*/

//====== I2C1 ======
	PCKEN2_I2C1 = 1;                    // I2C1
	SBI1CR1_SCK = SCK_HI_39_LO_42;    // ģʽƵʿ ; ģʽƵʽλ(SCL pin)ʱ ֮趨
	
	SBI1CR1_ACK = 1;                    // Ӧģʽ(ACK enable)
	SBI1CR1_BC = 0x00;                  // (λ)9bit = 8bit + 1bit(ACK)	
	

//--- [I2C1ΪMaster] ---           *I2C1ΪMaster
//------------bit7 | bit6 | bit5 | bit4  |  bit3  | bit2 | bit1~bit0 ----
//--- SBI1CR2 <MST>, <TRX>, <BB>, <PIN> and <SBIM>  <NA>   <SWRST>   ----
//--- <MST>   1 : Master
//            0 : Slave
//--- <TRX>   1 :    ; 0: 
//--- <BB>    1 : ʼ
//            0 : ֹͣ
//--- <PIN>	  1 : ȡжϷ
//
//--- <SBIM>  1 : Serial bus interface mode(ģʽ) / 0:Port mode
//--- <SWRST> ÿʼλ  
//------------------------------------------------------------------------	
	//---ΪMaster mode趨 SBICR2<MST> , <PIN> , <SBIM>
	SBI1CR2 = 0xC8;						// Master mode 1100 1000
	//SBI1CR2 = SBICR2_MST|SBICR2_PIN|SBICR2_SBIM;  // Master mode
	IFR_I2C1 = 0;                       // Д                      
	IER_I2C1 = 0;                       // I2C1 Д

	
}


//*********************************************************************
// 	: I2C1_IntEnable()
// 	: I2C1ж
//      : 
// شֵ   : 
// ע		: ִкῪж(IMF)**
//*********************************************************************
void I2C1_IntEnable(void)
{
	__ASM("DI");						// ֹпж
	IFR_I2C1 = 0;                       // ж
	IER_I2C1 = 1;	                    // I2C1ж(Enable)
	__ASM("EI");						// пж
}


//*********************************************************************
// 	: I2C1_IntDisable() 
// 	: ֹI2C1ж
//      : 
// شֵ   : 
// ע		: ִкῪж(IMF)**
//*********************************************************************
void I2C1_IntDisable(void)
{
	__ASM("DI");						// ֹпж
	IFR_I2C1 = 0;                       // ж
	IER_I2C1 = 0;	                    // I2C1жϽֹ 
	__ASM("EI");						// пж	
}


//*********************************************************************
// 	: I2C_Start() [Master mode]
// 	: I2CStart
//      : i2c: I2C_0, I2C_1       ѡһI2C 
//            adr: ͸Slaveװõλַ
// شֵ   : 
// ע		: 
//*********************************************************************
//SBI0CR2/SBI1CR2
//-----bit7 | bit6 | bit5 | bit4  |  bit3  | bit2 | bit1~bit0 ---------
//---  <MST>, <TRX>, <BB>, <PIN> and <SBIM>  <NA>   <SWRST>   ---------
//--- <MST>   1 : Master
//            0 : Slave
//--- <TRX>   1 :    ; 0: 
//--- <BB>    1 : ʼ
//            0 : ֹͣ
//--- <PIN>	  1 : ȡжϷ
//
//--- <SBIM>  1 : Serial bus interface mode(ģʽ) / 0:Port mode
//--- <SWRST> ÿʼλ  
//----------------------------------------------------------------------
void I2C_Start(unsigned char i2c,unsigned char adr){
	
	if(i2c==I2C_0){
		unsigned char tWait_I2C0 = 0;		// Ӧʱ,ȴ֮ʼֵ
		while(SBI0SR_BB);					// SBI0SR_BB: Bus status confirms is free ; 1 :busy  0: free

// 		SBI0CR1 = 0x10;						// ***ÿһ I2C_Start趨SBI0CR1
// 		//****** Write data to the registers before the start condition is generated ******	
// 		
// 	
 		SBI0DBR = adr;						// 趨 Slave Device (ID)λַ
// 		SBI0CR2 = 0xf8;						// Write "1" to SBI0CR2<MST>, <TRX>, <BB>, <PIN>  and <SBIM>to "1"
// 											// 1111 1000
// 											// 趨 Master,,ʼ,ȡжϷ  Ϊģʽ
		SBI0CR2 = SBICR2_MST|SBICR2_TX|SBICR2_BB|SBICR2_PIN|SBICR2_SBIM;
		
 		while(SBI0SR_PIN){};             	// ȴͷжϣʾTXɣPINΪ0
 		
 		
// 		// ---յλcheck <LRB>ӦźACK---
// 		while(SBI0SR_LRB = 1){					
// 				tWait_I2C0++;				// Ӧ,  ==> SCKᱣ
// 				if( tWait_I2C0>250 ){		// Ӧѭ		
// 					I2C_Stop(i2c);				// I2C stop -> release SCK
// 					break;
// 				}	
// 		}
		
	}	
	else if(i2c==I2C_1){
		unsigned char tWait_I2C1 = 0;		// Ӧʱ,ȴ֮ʼֵ
		while(SBI1SR_BB);					// SBI1SR_BB: Bus status confirms is free ; 1 :busy  0: free

// 		SBI1CR1 = 0x10;						// ***ÿһ I2C_Start趨SBI1CR1
// 		//****** Write data to the registers before the start condition is generated ******	
// 	
 		SBI1DBR = adr;						// 趨 Slave Device (ID)λַ
// 		SBI1CR2 = 0xf8;						// Write "1" to SBI1CR2<MST>, <TRX>, <BB>, <PIN>  and <SBIM>to "1"
// 											// 1111 1000
// 											// 趨 Master,,ʼ,ȡжϷ  Ϊģʽ
		
		SBI1CR2 = SBICR2_MST|SBICR2_TX|SBICR2_BB|SBICR2_PIN|SBICR2_SBIM;

 		while(SBI1CR2_PIN){};             	// ȴͷжϣʾTXɣPINΪ0
 		
// 		// ---յλcheck <LRB>ӦźACK---
// 		while(SBI1SR_LRB = 1){					
// 				tWait_I2C1++;				// Ӧ,  ==> SCKᱣ
// 				if( tWait_I2C1>250 ){		// Ӧѭ		
// 					I2C_Stop(i2c);		    // I2C stop -> release SCK
// 					break;
// 				}	
// 		}
// 

 	}
	
}

//*********************************************************************
// 	: I2C_ReStart() [Master mode]
// 	: I2C ReStart
//      : i2c: I2C_0, I2C_1       ѡһI2C 
//            adr: ͸Slaveװõλַ
// شֵ   : 
// ע		: 
//*********************************************************************
void I2C_ReStart(unsigned char i2c,unsigned char adr){

	if(i2c==I2C_0){
// 		SBI0CR2 = 0x18;						// Write "1" to SBI0CR2<PIN>  and <SBIM>to "1"
// 											// 00001 1000
// 											// 趨 ȡжϷ  Ϊģʽ
		SBI0CR2 = SBICR2_PIN|SBICR2_SBIM;
		while(SBI0SR_BB == 1);				// SBI0SR_BB: Bus status confirms is free ; 1 :busy  0: free	
		while(SBI0SR_LRB == 0);				// wait <LRB>=1
	}
	else if(i2c==I2C_1){
// 		SBI1CR2 = 0x18;						// Write "1" to SBI1CR2<PIN>  and <SBIM>to "1"
// 											// 00001 1000
// 											// 趨 ȡжϷ  Ϊģʽ
		SBI1CR2 = SBICR2_PIN|SBICR2_SBIM;
		while(SBI1SR_BB == 1);				// SBI1SR_BB: Bus status confirms is free ; 1 :busy  0: free	
		while(SBI1SR_LRB == 0);				// wait <LRB>=1
	}

	I2C_Start(i2c,adr);                 	// ͳ start + addressѶ

}


//*********************************************************************
// 	: I2C_Stop() [Master mode]
// 	: I2C Stop
//      : i2c: I2C_0, I2C_1       ѡһI2C 
// شֵ   : 
// ע		: 
//*********************************************************************
//SBI0CR2/SBI1CR2
//-----bit7 | bit6 | bit5 | bit4  |  bit3  | bit2 | bit1~bit0 ---------
//---        <MST>, <TRX>, <BB>, <PIN> and <SBIM>  <NA>   <SWRST>   ---
//--- <MST>   1 : Master
//            0 : Slave
//--- <TRX>   1 :    ; 0: 
//--- <BB>    1 : ʼ
//            0 : ֹͣ
//--- <PIN>	  1 : ȡжϷ
//
//--- <SBIM>  1 : Serial bus interface mode(ģʽ) / 0:Port mode
//--- <SWRST> ÿʼλ  
//----------------------------------------------------------------------
void I2C_Stop(unsigned char i2c){
	if(i2c==I2C_0){
// 	    SBI0CR2 = 0xd8;                 // Set SBI0CR2<MST>, <TRX> and <PIN> to "1" and SBI0CR2<BB> to "0"
//                                      // 1101 1000
//                                      // 趨 Master,,ֹͣ,ȡжϷ  ΪPortģʽ
        SBI0CR2 = SBICR2_MST|SBICR2_TX|SBICR2_PIN|SBICR2_SBIM;
	
        while(SBI0SR_BB);               // Bus free,SBI0SR_BB: Bus status confirms is free ; 1 :busy  0: free
    }
	else if(i2c==I2C_1){
// 		SBI0CR2 = 0xd8;                 // Set SBI0CR2<MST>, <TRX> and <PIN> to "1" and SBI0CR2<BB> to "0"
//                                      // 1101 1000
//                                      // 趨 Master,,ֹͣ,ȡжϷ  ΪPortģʽ
        SBI1CR2 = SBICR2_MST|SBICR2_TX|SBICR2_PIN|SBICR2_SBIM;
        while(SBI1SR_BB);               // Bus free,SBI1SR_BB: Bus status confirms is free ; 1 :busy  0: free
	}
}

//*********************************************************************
// 	: I2C_TXOneByte() [Master mode]
// 	: I2C һByte
//      : i2c: I2C_0, I2C_1       ѡһI2C 
//            TxBuf: 
// شֵ   : 
// ע		: 
//*********************************************************************
void I2C_TXOneByte(unsigned char i2c,unsigned char TxBuf){
	
	if(i2c==I2C_0){
		SBI0DBR = TxBuf;
		SBI0CR2 = SBICR2_MST|SBICR2_TX|SBICR2_BB|SBICR2_PIN|SBICR2_SBIM;
		while(SBI0CR2_PIN);             // TX
	}
	else if(i2c==I2C_1){
		SBI1DBR = TxBuf;
		SBI1CR2 = SBICR2_MST|SBICR2_TX|SBICR2_BB|SBICR2_PIN|SBICR2_SBIM;
		while(SBI1CR2_PIN);             // TX
	}
}



//*********************************************************************
// 	: I2C_RXOneByte() [Master mode]
// 	: I2C һByte
//      : i2c: I2C_0, I2C_1       ѡһI2C 
// شֵ   : ش
// ע		: 
//*********************************************************************
unsigned char I2C_RXOneByte(unsigned char i2c){
	if(i2c==I2C_0)
	{
		SBI0CR2 = SBICR2_MST|SBICR2_RX|SBICR2_BB|SBICR2_PIN|SBICR2_SBIM;
		SBI0DBR = 0x00;                 // Buf
		while(SBI0CR2_PIN == 1);        
		return SBI0DBR;
	}
	else if(i2c==I2C_1)
	{
		SBI1CR2 = SBICR2_MST|SBICR2_RX|SBICR2_BB|SBICR2_PIN|SBICR2_SBIM;
		SBI1DBR = 0x00;                 // Buf
		while(SBI1CR2_PIN == 1);
		return SBI1DBR;
	}
	else
		return 0;
}


//*********************************************************************
// 	: IsAck()
// 	: I2CǷACK
//      : i2c: I2C_0, I2C_1       ѡһI2C 
// شֵ   : 1: NACK   0: ACK
// ע		: 
//*********************************************************************
unsigned char IsAck(unsigned char i2c){

	if(i2c==I2C_0){
		return SBI0SR_LRB;
	}
	else if(i2c==I2C_1){
		return SBI1SR_LRB;
	}

	return I2C_NACK;
}


//*********************************************************************
// 	: I2C_AckEnable()
// 	: I2CǷһbitACKѶ
//      : i2c: I2C_0, I2C_1       ѡһI2C 
//            enable: 1     0 ֹ
// شֵ   :
// ע		: 
//*********************************************************************
void I2C_AckEnable(unsigned char i2c, unsigned char enable){
	if(i2c==I2C_0){
		SBI0CR1_ACK = enable;				// I2C0 һbitACKѶ
	}
	else if(i2c==I2C_1){
		SBI1CR1_ACK = enable;				// I2C1 һbitACKѶ
	}
}


//*********************************************************************
// 	: I2C_BufCount()
// 	: I2Cbit
//      : i2c: I2C_0, I2C_1       ѡһI2C 
//            bufcount: 
//                   BC_8bit      0x00
//                   BC_1bit      0x01
//                   BC_2bit      0x02
//                   BC_3bit      0x03
//                   BC_4bit      0x04
//                   BC_5bit      0x05
//                   BC_6bit      0x06
//                   BC_7bit      0x07 
// ע		:
//*********************************************************************
void I2C_BufCount(unsigned char i2c, unsigned char bufcount){

	if(i2c==I2C_0){	
		SBI0CR1_BC = bufcount;
	}
	else if(i2c==I2C_1){	
		SBI1CR1_BC = bufcount;
	}

}


//*********************************************************************
// 	: I2C_ReadState()
// 	: ȡI2C֮״̬
//      : i2c: I2C_0, I2C_1       ѡһI2C 
// شֵ   :
// ע		:
//*********************************************************************
unsigned char I2C_ReadState(unsigned char i2c){

	if(i2c==I2C_0){
		return SBI0SR;						// ȡI2C0֮״̬
	}
	else if(i2c==I2C_1){
		return SBI1SR;						// ȡI2C1֮״̬
	}
	else{
		return 0;
    }

}


//*********************************************************************
// 	: I2C_SetBufvalue()
// 	: 趨I2C buffer
//      : i2c: I2C_0, I2C_1       ѡһI2C 
//            data:  buffer 
// شֵ   :
// ע		:
//*********************************************************************
void I2C_SetBufvalue(unsigned char i2c,unsigned char data){

	if(i2c==I2C_0){
		SBI0DBR = data;
	}
	else if(i2c==I2C_1){
		SBI1DBR = data;
	}

}

//*********************************************************************
// 	: I2C_ReadBufvalue()
// 	: I2C buffer
//      : i2c: I2C_0, I2C_1       ѡһI2C 
// شֵ   : buffer
// ע		: 
//*********************************************************************
unsigned char I2C_ReadBufvalue(unsigned char i2c){

	if(i2c==I2C_0){
        return SBI0DBR;
	}
	else if(i2c==I2C_1){
		return SBI1DBR;
	}
	else{
		return 0;
	}
}


//*********************************************************************
// 	: I2C_FinishSlaveTx() [Slave mode]
// 	: I2C Slaveɳ,ҪΪͷI2C,һI2C˳ս
//      : i2c: I2C_0, I2C_1       ѡһI2C 
// شֵ   :
// ע		: 
//*********************************************************************
void I2C_FinishSlaveTx(unsigned char i2c){

	if(i2c==I2C_0){
		SBI0CR2 = 0x58;
		SBI0CR2 = 0x18;
	}
	else if(i2c==I2C_1){
		SBI1CR2 = 0x58;
		SBI1CR2 = 0x18;
	}

}


//*********************************************************************
// 	: I2C_Reset()
// 	: I2C software reset. SBI0CR1,I2C0AR,SBI0CR2 ,SBI0CR2<SBIM>
//      : i2c: I2C_0, I2C_1       ѡһI2C 
// شֵ   :
// ע		: 
//*********************************************************************
void I2C_Reset(unsigned char i2c){

	if(i2c==I2C_0){
		SBI0CR2 = 0x1A;
		SBI0CR2 = 0x19;
	}
	else if(i2c==I2C_1){
		SBI1CR2 = 0x1A;
		SBI1CR2 = 0x19;
	}

}


//*********************************************************************
// 	: __interrupt IntI2C0()
// 	: I2C0 жӳ
// ע		:
//*********************************************************************
void __interrupt IntI2C0(void)
{
	__asm("NOP");						// ָ

	//I2C_Slave_Int(I2C_0,&i2c_slave);
}


//*********************************************************************
// 	: __interrupt IntI2C1()
// 	: I2C1 жӳ
// ע		:
//*********************************************************************
void __interrupt IntI2C1(void)
{
	__asm("NOP");						// ָ

	
}


//*********************************************************************
// 	: I2C_Master_Write()
// 	: 
//      : i2c: I2C_0, I2C_1       ѡһI2C 
//            pi2c: ָ
// شֵ   : 1: ɹ 0:
// ע		:
//*********************************************************************
unsigned char I2C_Master_Write(unsigned char i2c,I2C_MasterPacket* pi2c){
	unsigned char cnt;
	
	I2C_Start(i2c,(unsigned char)(pi2c->adr)|I2C_Write);

	if(IsAck(i2c)==I2C_NACK){
		I2C_Stop(i2c);
		return 0;
	}		
	
	for(cnt=0; cnt<pi2c->len; cnt++){
		I2C_TXOneByte(i2c,*pi2c->pBuf++);  // I2C һByte
		if(IsAck(i2c)==I2C_NACK){
		    I2C_Stop(i2c);
		    return 0;
	    }	
	}

	I2C_Stop(i2c);

	return 1;
}



//*********************************************************************
// 	: I2C_Master_Read()
// 	: 
//      : i2c: I2C_0, I2C_1       ѡһI2C 
//            pi2c: ָ
// شֵ   : 1: ɹ 0:
// ע		:
//*********************************************************************
unsigned char I2C_Master_Read(unsigned char i2c,I2C_MasterPacket* pi2c)
{
	unsigned char cnt,length;
	
	
	I2C_Start(i2c,(unsigned char)(pi2c->adr)|I2C_Read); // I2CStart
	
	if(IsAck(i2c)==I2C_NACK){					  // I2CǷACKΪNACKI2C ִзStop
		I2C_Stop(i2c);
		return 0;
	}		
	
    *pi2c->pBuf++ = pi2c->len = I2C_RXOneByte(i2c);   // The first byte is data packet length 
	pi2c->len--;
		
	for(cnt=0; cnt<pi2c->len; cnt++){
		if(cnt == pi2c->len-1){
			I2C_AckEnable(i2c,0);                 // ACK disable 
			I2C_BufCount(i2c,BC_8bit);            // 趨8bit
			*pi2c->pBuf++ = I2C_RXOneByte(i2c);
			I2C_BufCount(i2c,BC_1bit);            // 1bit ACK
			I2C_TXOneByte(i2c,0xFF);              // дNack dataΪ0xFF			
			I2C_AckEnable(i2c,1);                 // ACK enable 
			I2C_BufCount(i2c,BC_8bit);            // 8bit
		}
		else{
    		*pi2c->pBuf++ = I2C_RXOneByte(i2c); // 8bit+1bit ACK
		}		
	}
	
	I2C_Stop(i2c);								 // I2C ִзStop
	
	return 1;

}

/* ------------------- ļβ  ---------------------- */
