//*************************************************************************************
// 	: SQ7515_RTC.c
// 汾		: V1.0
// 		: RTC ʹú
// ע		: RTC غ㼯ڱӳ
//**************************************************************************************
#include "main.h"

extern RTC_Perpetual_Calendar_Time rtc;                             
extern RTC_ALARM rtc_alarm;

unsigned char RTC_1sec_actFlag;		   // ÿķ
unsigned char RTC_alarm_actFlag;		   // ӵķ

//unsigned char RTC_timeover_actFlag;	   // ʱʱķ
//*********************************************************************
// 	: RTC_Setup()
// 	: 趨RTCʱ
// ע		:
//*********************************************************************
void RTC_Setup()
{
	PCKEN6_RTC = 1;	                       // RTCܿ( Enable)

	// 趨ʱ:2019/11/18 Monday 15:06:50
	rtc.year = 19;
	rtc.mon = 11;
	rtc.week = 1;
	rtc.day = 18;
	rtc.hour = 15;
	rtc.min = 6;
	rtc.sec = 50;
	RTC_SetDate(&rtc);                  	// RTC
}

	
//*********************************************************************
// 	: Alarm_Setup()
// 	: 趨ʱ
// ע		:
//*********************************************************************	
void Alarm_Setup()
{
	// 趨ʱ:18 Monday 15:07:00
	rtc_alarm.week = 1|0x80;
	rtc_alarm.day = 18|0x80;
	rtc_alarm.hour = 15|0x80;
	rtc_alarm.min = 7;
	RTC_SetAlarm(&rtc_alarm);               // 趨ʱ
	RTC_IntEnable(RTC_AIE,1);			    // RTCж
	RTC_Start();                            // RTC 			
}

//*********************************************************************
// 	: RTC_Output_Disable()
// 	: RTCֹ
// ע		:
//*********************************************************************
void RTC_Output_Disable(void)
{
    RTCCR0_CLKOEN = 0;
}


//*********************************************************************
// 	: RTC_Init()
// 	: RTCʼ
// ע		:
//*********************************************************************
void RTC_Init()
{
	PCKEN6_RTC = 1;	                        // RTCܿ( Enable)

}


//*********************************************************************
// 	: RTC_IntEnable()
// 	: RTC ж
// ע		:
//*********************************************************************
void RTC_IntEnable(unsigned char intsel,unsigned char enable){
	__ASM("DI");							// ֹпж
	
	IER_RTC = enable;		                
	RTCCR1 = intsel;
	
	__ASM("EI");							// пж
}

//*********************************************************************
// 	: RTC_IntDisable()
// 	: RTC жϳ
// ע		:
//*********************************************************************
void RTC_IntDisable(){
	__ASM("DI");							// ֹпж
	IER_RTC = 0;		
	RTCCR1 =  0x00;              
	__ASM("EI");							// пж
}



//*********************************************************************
// 	: RTC_SetDate()
// 	: RTC 趨ʱ ,,Сʱ,,,,
// ע		: 趨ʱὫֵתΪBCD
//*********************************************************************
void RTC_SetDate(RTC_Perpetual_Calendar_Time* prtc){
    RTCSEC = ((prtc->sec/10)<<4)|(prtc->sec%10);		    // 趨ȫʱ ,  60  0~59 
	RTCMIN = ((prtc->min/10)<<4)|(prtc->min%10); 	        // 趨ȫʱ ,   1  0~59 
	RTCHR = ((prtc->hour/10)<<4)|(prtc->hour%10); 		    // 趨ȫʱ Сr, 1Сr  0~23 r
	RTCDAY = ((prtc->day/10)<<4)|(prtc->day%10); 	        // 趨ȫʱ ,     1  1~31 
	RTCWDAY = (prtc->week&0x7); 	                        // 趨ȫʱ , 1 ~
	RTCMONTH = ((prtc->mon/10)<<4)|(prtc->mon%10); 	        // 趨ȫʱ , 1 1~12
	RTCYEAR = ((prtc->year%100/10)<<4)|(prtc->year%10); 	// 趨ȫʱ , 1~99
}


//*********************************************************************
// 	: RTC_Refresh()
// 	: RTC ʱ
// ע		: 趨ʱὫֵתΪBCD
//*********************************************************************
void RTC_Refresh(RTC_Perpetual_Calendar_Time* prtc){
	prtc->sec = (((RTCSEC&0x70)>>4)*10)+(RTCSEC&0x0F);
	prtc->min = (((RTCMIN&0x70)>>4)*10)+(RTCMIN&0x0F);
	prtc->hour = (((RTCHR&0x30)>>4)*10)+(RTCHR&0x0F);
	prtc->day = (((RTCDAY&0x30)>>4)*10)+(RTCDAY&0x0F);
	prtc->week = (RTCWDAY&0x0F);
	prtc->mon = (((RTCMONTH&0x10)>>4)*10)+(RTCMONTH&0x0F);
	prtc->year = (((RTCYEAR&0xF0)>>4)*10)+(RTCYEAR&0x0F);
}


//*********************************************************************
// 	: RTC_SetAlarm()
// 	: 趨 (ʱӾ)ʱ ,Сʱ,,
// ע		: 趨ʱὫֵתΪBCD
//*********************************************************************
void RTC_SetAlarm(RTC_ALARM* palarm){
	// ж
    RTCALMIN = ((palarm->min/10)<<4)|(palarm->min%10); 	    // 趨ȫʱ ,   1  0~59 
	RTCALHR = ((palarm->hour/10)<<4)|(palarm->hour%10);	    // 趨ȫʱ Сr, 1Сr  0~23 r
	RTCALDAY = ((palarm->day/10)<<4)|(palarm->day%10); 	    // 趨ȫʱ ,     1  1~31 
	RTCALWDAY = ((palarm->week/10)<<4)|(palarm->week%10); 	// 趨ȫʱ , 1 ~
}


//*********************************************************************
// 	: RTC_Start()
// 	: RTC 
// ע		:
//*********************************************************************
void RTC_Start(void)
{
	RTCCR0_RTCEN = 1;		                  // RTC 
}


//*********************************************************************
// 	: RTC_Stop()
// 	: RTC ֹͣ
// ע		:
//*********************************************************************
void RTC_Stop(void)
{
	RTCCR0_RTCEN = 0;			              // RTC ֹͣ
}

//*********************************************************************
// 	: RTC_TimerSetAndEnable()
// 	: RTC ʱ趨
// ע		:
//*********************************************************************
void RTC_TimerSetAndEnable(void)
{
	RTCCR0 = 0x00;							  // RTC 趨
	RTCCR1 |= 0x08;							  // ʱʱж (RTCCR1_TOIE = 1)

	//RTCTMRCR_CONT = 0;					  // ʱģʽ
	RTCTMRCR_CONT = 1;						  // ʱģʽ

	RTCTMRTO = 0x02;						  // RTC ʱʱֵ(ֵ0)
}


//*********************************************************************
// 	: RTC_TimerStart()
// 	: RTC ʱ()
// ע		:
//*********************************************************************
void RTC_TimerStart(void)
{
	RTCTMRCR_TMREN = 1;						  // RTCʱ
}

//*********************************************************************
// 	: RTC_TimerStop()
// 	: RTCʱֹܽ(ֹͣ)
// ע		:
//*********************************************************************
void RTC_TimerStop(void)
{
	RTCTMRCR_TMREN = 0;						  // RTCʱֹܽ
	while(RTCTMRCR_TMRST != 0); 			  // 鶨ʱ״̬Ƿ޹(Ƿֹͣ?)
}


//*********************************************************************
// 	: __interrupt IntRTC()
// 	: RTC жӳ
// ע		:
//*********************************************************************
void __interrupt IntRTC(void)
{
	__asm("NOP");					    	  // ָ
	
	//--- ж(ÿж) ---
	if (RTCCR1_SECF == 1 )			    	  // жϷ
	{
		RTCCR1 = (RTCCR1&0x0F)|0x40;    	  // жϱ
		
		RTC_1sec_actFlag = 1;				  // Oÿķ

	}
	
	
	//--- ж ---
	if(RTCCR1_ALF == 1)						  // жϷ
	{
		RTCCR1 = (RTCCR1&0x0F)|0x20;		  // жϱ־
		
		
		RTC_alarm_actFlag = 1;				  // Oӵķ
	}
	
	
	//--- ʱʱж ---
/*
	if (RTCCR1_TOF == 1)			    	  // ʱʱжϷ
	{
		RTCCR1 = (RTCCR1&0x0F)|0x80;		  // ʱʱжϱ
		RTC_timeover_actFlag = 1;			  // O ʱʱķ
	}
*/


}


