//*************************************************************************************
// 	: main.c
// 汾		: V1.0 2022/05/25
// 		: 
// ˵	: 1. ͳ ECB ģʽ.
//
//            2. ʹ˵ĴвUART1 Խӣն˻߳ʽ(磺
//               , AccessPort...)в.
//
// ע		: 
//            1. I2C1ΪMaster
//		             (P2.1)ΪSDA1
//		             (P2.2)ΪSCL1
//	             *SDA,SCLⲿ
//
//            2. [] UART1_TX(P2.5)
//                          UART1_RX(P2.6)
//                          : 115200
// 
//			     [] 1  BTN1(P3.0)(EINT0)
//
//				 [LED]  LED 1  (P2.0)
//**************************************************************************************
#ifndef	IO_MEM
#define	IO_MEM
#endif
/* ---------------------- ͷļ ------------------------------ */
#include "main.h"

/* ---------------------- ṹ ------------------------------ */

/* ----------------------  ------------------------------------ */

/* ---------------------- ȫ ---------------------------- */

/* ---------------------- ر ---------------------------- */

SecureUnit_Command_Packet SecureUnit_CMD;
SecureUnit_Response_Packet SecureUnit_RESP;

///Key
const uint8_t KEY[3][16] = {{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},
                            {0x10,0xa5,0x88,0x69,0xd7,0x4b,0xe5,0xa3,0x74,0xcf,0x86,0x7c,0xfb,0x47,0x38,0x59},
                            {0x90,0xf4,0x2e,0xc0,0xf6,0x83,0x85,0xf2,0xff,0xc5,0xdf,0xc0,0x3a,0x65,0x4d,0xce}
                           };

///Plaintext						   
const uint8_t PT[3][16] =  {{0xf3,0x44,0x81,0xec,0x3c,0xc6,0x27,0xba,0xcd,0x5d,0xc3,0xfb,0x08,0xf2,0x73,0xe6},
                            {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},
                            {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00}
                           };

///Ciphertext						   
const uint8_t CT[3][16] =  {{0x03,0x36,0x76,0x3e,0x96,0x6d,0x92,0x59,0x5a,0x56,0x7c,0xc9,0xce,0x53,0x7f,0x5e},
                            {0x6d,0x25,0x1e,0x69,0x44,0xb0,0x51,0xe0,0x4e,0xaa,0x6f,0xb4,0xdb,0xf7,0x84,0x65},
                            {0x7a,0x20,0xa5,0x3d,0x46,0x0f,0xc9,0xce,0x04,0x23,0xa7,0xa0,0x76,0x4c,0x6c,0xf2}
                           };
/* ---------------------- غԭ ------------------------ */


/* ---------------------- ʽa ---------------------------------- */

//*********************************************************************
// 	: main()
// 	: 
//      : 
// شֵ   : 
// ע		: 
//*********************************************************************
void main()
{
    uint8_t temp;

/* ---------------------- ϵͳʼ ------------------------ */
	PLLCR0_PLLEN  = 1;                  //  PLL
	while(PLLCR0_PLLRDY ==0);			// ȴ PLL 
	CLKCR0_SCKPSC = 1;                  // ϵͳƵʳ2   (48M/2=24MHz) 
    CLKCR0_SCKSRC = 1;                  // ʱԴлPLL
	while(CLKCR0_SCKRDY ==0);			// ȴ ϵͳʱ 
/* ---------------------- ܽųʼ ------------------------ */
    P0PU = 0xFF;                        // .
    P1PU = 0xFF;
    P2PU = 0xFF;
    P3PU = 0xFF;
    P4PU = 0xFF;
    P5PU = 0xFF;

    P2OE_P0 = 1;                        // 趨P2.0 ܽΪ
    P2PU_P0 = 0;                        // 趨P2.0 .

    P3OE_P7 = 1;                        // 趨P3.7 ܽΪ
    P3PU_P7 = 0;                        // 趨P3.7 .

    P3OE_P6 = 1;                        // 趨P3.6 ܽΪ
    P3PU_P6 = 0;                        // 趨P3.6 .
	
    LED1_out = 1;                       // ʼ趨LED1Ϊ״̬
    LED2_out = 1;                       // ʼ趨LED2Ϊ״̬
    LED3_out = 1;                       // ʼ趨LED3Ϊ״̬
/* ---------------------- EINT ʼ ------------------------ */
    EINT_Init();                        // EINT ʼ趨
    EINT_IntEnable();                   // EINT ж
/* ---------------------- I2C1 ʼ ------------------------ */
    I2C1_Init();                        // I2C1Master , I2C1 жϽ 
/* ---------------------- UART1 ʼ ------------------------ */
    UART1_Init();
    UART1_SetBaudRate(SYSCLK_24MHZ_BAUD_115200);
	UART1_Start();
/* ---------------------- TCA0 ʼ ------------------------ */    
    TCA0_Timer_Init();
    TCA0_IntEnable();
/* ---------------------- CRC ʼ ------------------------ */
    CRC_Init();
///-------------------------------------------------------------    

    UART_SendCString("SecureUnit API Example: Lecagy ECB Encrypt\n");


    while(1){
        UART_SendCString("\nSelect encrypt test pattern NO.: 0~2 \n");
        temp = UART1_RX_OneByte();
        UART1_TX_OneByte(temp);

        temp -= 0x30;        

        UART_SendCString("\nECB encrypt test\n");
        ///Setup Key 0
        SecureUnit_CMD.Length = 25; 
        SecureUnit_CMD.Opcode = OpCode_BlockWrite;	// Block write command
        SecureUnit_CMD.Mode = 0x00;
        SecureUnit_CMD.Param1 = 0xF200;				// Write Key 0
        SecureUnit_CMD.Param2 = 0x0010;
        SecureUnit_CMD.pDIN = (uint8_t*)&KEY[temp][0];
        UART_SendCString("Key: "); UART_SendHex((uint8_t*)&KEY[temp][0],16);
			  
        if(SecureUnit_Command_Execute(&SecureUnit_CMD,&SecureUnit_RESP)==CMD_RET_OK){
            if(SecureUnit_RESP.CMDST==0){
                UART_SendCString("Key write success!\n");
            }
            else{
                UART_SendCString("Key write fail!\n");
            }
        }
        else{
            UART_SendCString("Key write fail!\n");
        }

        ///ECB mode ecnryption 
        SecureUnit_CMD.Length = 25; 
        SecureUnit_CMD.Opcode = OpCode_Legacy;	  // Legacy command 					  
        SecureUnit_CMD.Mode = 0x00;
        SecureUnit_CMD.Param1 = 0x0000;			  // Use Key 0 
        SecureUnit_CMD.Param2 = 0x0000; 
        SecureUnit_CMD.pDIN = (uint8_t*)&PT[temp][0];
        UART_SendCString("Plaintext: "); UART_SendHex((uint8_t*)&PT[temp][0],16);
			  
        if(SecureUnit_Command_Execute(&SecureUnit_CMD,&SecureUnit_RESP)==CMD_RET_OK){
			  
            if(SecureUnit_RESP.CMDST==0){
			      
                UART_SendCString("ECB encrypt command execute success!\n");
                if(memcmp(SecureUnit_RESP.DOUT,&CT[temp][0],16)==0){   // ȽϽǷȷ ?
                    UART_SendCString("ECB encrypt success!\n");  
                    //UART_SendCString("Ciphertext: "); UART_SendHex((uint8_t*)&CT[temp][0],16);
                    //UART_SendCString("Encrypt result: "); UART_SendHex(SecureUnit_RESP.DOUT,16);
						
                }
                else{					
                    UART_SendCString("ECB encrypt fail!\n");  
                    //UART_SendCString("Ciphertext: "); UART_SendHex((uint8_t*)&CT[temp][0],16);
                    //UART_SendCString("Encrypt result: "); UART_SendHex(SecureUnit_RESP.DOUT,16);
                }
					
                UART_SendCString("Ciphertext: "); UART_SendHex((uint8_t*)&CT[temp][0],16);
                UART_SendCString("Encrypt result: "); UART_SendHex(SecureUnit_RESP.DOUT,16);					
            }
            else{
				  
                UART_SendCString("ECB encrypt command execute fail! ReturnCode: ");
                UART_PutByte(UART_1,SecureUnit_RESP.CMDST);UART_PutCrlf(); 
            }
        }
        else{
            UART_SendCString("ECB encrypt command execute fail!\n");
        }
    }
}

/*---------------------------------------------------------------------------------------------*/
//*********************************************************************
// 	: Delay_us()
// 	: 
// ע		: 
//*********************************************************************
void Delay_us(uint16_t val)
{

    TCA0_SetPeriod(val*6);
    TCA0_Int_Flag = 0;
    TCA0_Start();
    while(!TCA0_Int_Flag);
    TCA0_Stop();
  
}

/* ---------------------- жϷ ------------------------ */
void __interrupt OnlyReti(void){
    __asm("NOP");                       // ָ
}

void __interrupt_n OnlyRetn(void){
    __asm("NOP");                       // ָ
}

void __interrupt_n IntWDT(void){
    __asm("NOP");                       // ָ
}

void __interrupt_n IntSWI(void){        // SWIλжϷ
    PRSTR7 = 0x5a;
    PRSTR7 = 0xa5;
    PRSTR7 = 0xc3;
    PRSTR7 = 0x3c;	
}
/* -------------------  жϷ ---------------------- */


/* -------------------- SQ7515ж ---------------------- */ 
//  [ ж ] Ҫжид
//  1. ʹ֮߳жж֮OnlyRetiΪӦж
//  2. ӦڵַжƣֱӸ
//
//	   ʹⲿж0ӦжϱеOnlyRetiΪIntEXT0
//			 IntEXT0,		/* 0xffd6 : IntEXT0			*/	//ⲿж0
// ------------------------------------------------------------- //
#pragma section const INT_VECTOR1 0xff40
void * const IntTbl1[] = {											
	OnlyReti,				/* 0xff40 : Reserved		*/									
	OnlyReti,				/* 0xff42 : Reserved		*/									
	OnlyReti,				/* 0xff44 : Reserved		*/									
	OnlyReti,				/* 0xff46 : Reserved		*/								
	OnlyReti,				/* 0xff48 : Reserved		*/									
	OnlyReti,				/* 0xff4a : Reserved		*/									
	OnlyReti,				/* 0xff4c : Reserved		*/									
	OnlyReti,				/* 0xff4e : Reserved		*/									
	OnlyReti,				/* 0xff50 : Reserved		*/									
	OnlyReti,				/* 0xff52 : Reserved		*/									
	OnlyReti,				/* 0xff54 : Reserved		*/									
	OnlyReti,				/* 0xff56 : Reserved		*/									
	OnlyReti,				/* 0xff58 : IntTCA7			*/	//жԴ:TCA7 16λʱ								
	OnlyReti,				/* 0xff5a : IntTCA6			*/	//жԴ:TCA6 16λʱ							
	OnlyReti,				/* 0xff5c : Reserved		*/									
	OnlyReti,				/* 0xff5e : Reserved		*/									
	OnlyReti,				/* 0xff60 : Reserved		*/									
	OnlyReti,				/* 0xff62 : Reserved		*/									
	OnlyReti,				/* 0xff64 : Reserved		*/									
	OnlyReti,				/* 0xff66 : Reserved		*/									
	OnlyReti,				/* 0xff68 : Reserved		*/									
	OnlyReti,				/* 0xff6a : Reserved		*/									
	OnlyReti,				/* 0xff6c : IntTX2			*/	//жԴ:UART2 TX2								
	OnlyReti,				/* 0xff6e : IntRX2			*/	//жԴ:UART2 RX2							
	OnlyReti,				/* 0xff70 : Reserved		*/									
	OnlyReti,				/* 0xff72 : Reserved		*/									
	OnlyReti,				/* 0xff74 : Reserved		*/									
	OnlyReti,				/* 0xff76 : IntTCA5			*/	//жԴ:TCA5 16λʱ								
	OnlyReti,				/* 0xff78 : IntTCA4			*/	//жԴ:TCA4 16λʱ								
	OnlyReti,				/* 0xff7a : Reserved		*/									
	OnlyReti,				/* 0xff7c : Reserved		*/									
	OnlyReti,				/* 0xff7e : Reserved		*/									
	OnlyReti,				/* 0xff80 : Reserved		*/									
	OnlyReti,		    	/* 0xff82 : Reserved		*/									
	OnlyReti,	    		/* 0xff84 : Reserved		*/									
	OnlyReti,				/* 0xff86 : Reserved		*/									
	OnlyReti,				/* 0xff88 : Reserved		*/									
	OnlyReti,				/* 0xff8a : Reserved		*/									
	OnlyReti,				/* 0xff8c : IntSIO1			*/	//жԴ:SIO 1								
	OnlyReti,				/* 0xff8e : IntI2C1			*/	//жԴ:I2C 1						
	OnlyReti,				/* 0xff90 : IntTX1			*/	//жԴ:UART1 TX1							
	OnlyReti,				/* 0xff92 : IntRX1			*/	//жԴ:UART1 RX1								
	OnlyReti,				/* 0xff94 : Reserved		*/									
	OnlyReti,				/* 0xff96 : Reserved		*/									
	OnlyReti,				/* 0xff98 : Reserved		*/									
	OnlyReti,				/* 0xff9a : IntTCA3			*/	//жԴ:TCA3 16λʱ							
	OnlyReti,				/* 0xff9c : IntTCA2			*/	//жԴ:TCA2 16λʱ								
	OnlyReti,				/* 0xff9e : Reserved		*/									
	OnlyReti,				/* 0xffa0 : IntMAC			*/	//жԴ:˷								
	OnlyReti,				/* 0xffa2 : IntEXT7			*/	//ⲿж7								
	OnlyReti,				/* 0xffa4 : IntEXT6			*/	//ⲿж6								
	OnlyReti,				/* 0xffa6 : IntEXT5			*/	//ⲿж5								
	OnlyReti,				/* 0xffa8 : IntEXT4			*/	//ⲿж4								
	OnlyReti,				/* 0xffaa : Reserved		*/									
	OnlyReti,				/* 0xffac : Reserved		*/									
	OnlyReti,				/* 0xffae : Reserved		*/							
	OnlyReti,				/* 0xffb0 : IntDIC			*/	//жԴ:DIC								
	OnlyReti,				/* 0xffb2 : Reserved		*/							
	OnlyReti,				/* 0xffb4 : Reserved		*/									
	OnlyReti,				/* 0xffb6 : Reserved		*/									
	OnlyReti,				/* 0xffb8 : Reserved		*/									
	OnlyReti,				/* 0xffba : Reserved		*/									
	OnlyReti,				/* 0xffbc : Reserved		*/									
	OnlyReti,				/* 0xffbe : Reserved		*/									
	OnlyReti,				/* 0xffc0 : Reserved		*/									
	OnlyReti,				/* 0xffc2 : Reserved		*/									
	OnlyReti,				/* 0xffc4 : IntFMC			*/	//жԴ:Flash								
	OnlyReti,				/* 0xffc6 : Reserved		*/					
	OnlyReti,				/* 0xffc8 : Reserved		*/									
	OnlyReti,				/* 0xffca : Reserved		*/									
	OnlyReti,				/* 0xffcc : Reserved		*/									
	OnlyReti,               /* 0xffce : IntADC			*/	//жԴ:ADC								
	OnlyReti,				/* 0xffd0 : IntEXT3			*/	//ⲿж3
	IntEXT2,				/* 0xffd2 : IntEXT2			*/	//ⲿж2
	IntEXT1,				/* 0xffd4 : IntEXT1			*/	//ⲿж1
	IntEXT0,				/* 0xffd6 : IntEXT0			*/	//ⲿж0   
	OnlyReti,				/* 0xffd8 : IntSIO0			*/	//жԴ:SIO 0								
	OnlyReti,				/* 0xffda : IntI2C0			*/	//жԴ:I2C 0								
	OnlyReti,				/* 0xffdc : IntTX0			*/	//жԴ:UART0 TX0								
	OnlyReti,				/* 0xffde : IntRX0			*/	//жԴ:UART0 RX0								
	OnlyReti,				/* 0xffe0 : Reserved		*/									
	OnlyReti,				/* 0xffe2 : Reserved		*/									
	OnlyReti,				/* 0xffe4 : Reserved		*/									
	OnlyReti,				/* 0xffe6 : IntTCA1			*/	//жԴ:TCA1 16λʱ								
	IntTCA0,				/* 0xffe8 : IntTCA0			*/	//жԴ:TCA0 16λʱ								
	OnlyReti,				/* 0xffea : Reserved		*/									
	OnlyReti,				/* 0xffec : Reserved		*/									
	OnlyReti,			    /* 0xffee : IntRTC			*/	//жԴ:ʵʱʱRTCʱ								
	OnlyReti,				/* 0xfff0 : IntTBT			*/  //жԴ:ʱTBTʱ				
	OnlyReti,				/* 0xfff2 : Reserved		*/									
	OnlyReti,				/* 0xfff4 : IntCFD			*/	//жԴ:ʱʧЧ								
	OnlyReti,				/* 0xfff6 : IntLVD			*/	//жԴ:͵ѹLVD							
	IntWDT,					/* 0xfff8 : IntWDT			*/	//non-maskable жԴ:Źʱ		
	(void *)0xffff,			/* 0xfffa : Reserved		*/									
	IntSWI,					/* 0xfffc : IntSWI/INTUNDEF */	//non-maskable		
	STARTUP					/* 0xfffe : RESET			*/	//non-maskable			
};
#pragma section const
/* -------------------  SQ7515ж ---------------------- */

/* ---------------------- ļβ -------------------------------- */